unit Unit1;

{

 Picking demo (c)2002 by Paul TOTH <tothpaul@free.fr>
 http://tothpaul.free.fr

 based on TMT Pascal - DirectX demo

 *  Direct3D sample from DirectX 8.0 SDK Delphi adaptation by Alexey Barkovoy *
 *  E-Mail: clootie@reactor.ru                                                *

}

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AppEvnts, ExtCtrls,  DelphiGL, Math3D;

Type
  TForm1 = class(TForm)
    Timer1: TTimer;
    ApplicationEvents1: TApplicationEvents;
    procedure Timer1Timer(Sender: TObject);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
   // OpenGL stuffs
    fDC:HDC;
    fGL:THandle;
    { Dclarations prives }
    fps:integer;
    texture:integer;
    mm,mx,my:integer;
    rx,tx,ty:single;
    procedure SetupTiger;
    procedure Selection;
    function Intersection(const orig,dir,a,b,c:TVector3f):single;
    procedure wmEraseBkGnd(var msg:TMessage); message wm_erasebkgnd;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

uses Tiger;

{$R *.dfm}

Function PowerOf2(Target:integer):integer;
 begin
  Result:=1;
  while Result<Target do Result:=Result shl 1;
 end;

Procedure rgb2bgr(p:pointer;w,h,d:integer);
 var
  rgb:pchar;
  x,y:integer;
  t:char;
 begin
  rgb:=p;
  for y:=0 to h-1 do
   for x:=0 to w-1 do begin
    t:=rgb[0];
    rgb[0]:=rgb[2];
    rgb[2]:=t;
    inc(integer(rgb),d);
   end;
 end;

Type
 TBMP256=packed record
  bfType:array[1..2] of char;
  bfSize:LongInt;
  bfReserved:LongInt;
  bfOffBits:LongInt;
 //---
  biSize:LongInt;
  biWidth:LongInt;
  biHeight:LongInt;
  biPlanes:word;
  biBitCount:word;
  biCompression:longint;
  biSizeImage:longint;
  biXPelsPerMeter:longint;
  biYPelsPerMeter:longint;
  biClrUsed:Longint;
  biClrImportant:longint;
 end;

function LoadBitmap(FileName:string):integer;
 var
  f:file;
  bmp:TBMP256;
  w,h:integer;
  pix:pchar;
  pal:array[#0..#255] of integer;
  tex:pchar;
  pl :pinteger;
  pi :pinteger;
  x,y:integer;
  ofs:integer;
 begin
  assign(f,FileName);
  reset(f,1);
  blockread(f,bmp,sizeof(bmp));
  blockread(f,pal,sizeof(pal));
  GetMem(pix,bmp.biWidth*bmp.biHeight);
  seek(f,bmp.bfOffBits);
  BlockRead(f,pix^,bmp.biWidth*bmp.biHeight);
  close(f);

  rgb2bgr(@pal,256,1,4);

  w:=PowerOf2(bmp.biWidth);
  h:=PowerOf2(bmp.biHeight);
  GetMem(tex,4*w*h);
  pl:=pointer(tex);
  ofs:=bmp.biWidth*bmp.biHeight;
  for y:=0 to bmp.biHeight-1 do begin
   pi:=pl;
   dec(ofs,bmp.biWidth);
   for x:=0 to bmp.biWidth-1 do begin
    pi^:=pal[pix[ofs+x]];
    inc(pi);
   end;
   inc(pl,w);
  end;
  FreeMem(pix);

  glGenTextures(1,@Result);
  glBindTexture(GL_TEXTURE_2D, Result);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexImage2D(GL_TEXTURE_2D, 0, 4, w,h,0, GL_RGBA, GL_UNSIGNED_BYTE, tex);

  FreeMem(tex);
 end;

function TForm1.Intersection(const orig,dir,a,b,c:TVector3f):single;
 var
  edge1:TVector3f;
  edge2:TVector3f;
  pvec :TVector3f;
  det  :single;
  tvec :TVector3f;
  u    :single;
  qvec :TVector3f;
  v    :single;
  t    :single;
 begin
  edge1:=SubVector(b,a);
  edge2:=SubVector(c,a);
  pvec:=CrossProduct(dir,edge2);
  det:=DotProduct(edge1,pvec);
  if (det < 0.0001) then begin
    Result:=-1;
    Exit;
  end;
  tvec:=SubVector(orig,a);
  u:=DotProduct(tvec, pvec);
  if(u < 0.0) or (u > det) then begin
    Result:=-1;
    Exit;
  end;
  qvec:=CrossProduct(tvec, edge1);
  v:=DotProduct(dir, qvec);
  if (v < 0.0) or (u + v > det) then begin
    Result:=-1;
    Exit;
  end;

  t := DotProduct(edge2, qvec);

  det:= 1.0 / det;
  t:= t * det-orig.x;
  u:= u * det-orig.y;
  v:= v * det-orig.z;

  Result:=t*t+u*u+v*v;
 end;

procedure TForm1.Selection;
var
{
 model    :TMatrix16d;
 project  :TMatrix16d;
 view     :TMatrix4i;
 ux,uy,uz :double;
}
 x,y      :double;
 modelf   :TMatrix16f;
 projectf :TMatrix16f;
 unproject:TMatrix16f;
 eye,mouse:TVector3f;
 i,a,b,c  :integer;
 v1,v2,v3 :TVector3f;
 dist     :single;
 nearest  :integer;
 ndist    :single;
begin
 x:=mx;
 y:=ClientHeight-my;
{
 glGetDoublev(GL_MODELVIEW_MATRIX,model);
 glGetDoublev(GL_PROJECTION_MATRIX,project);
 glGetIntegerv(GL_VIEWPORT,view);
 gluUnProject(x,y,0,model,project,view,ux,uy,uz);
 eye.x:=ux;
 eye.y:=uy;
 eye.z:=uz;
 gluUnProject(x,y,1,model,project,view,ux,uy,uz);
 mouse.x:=ux;
 mouse.y:=uy;
 mouse.z:=uz;
}

 x:=2*(x/ClientWidth )-1; // -1..+1
 y:=2*(y/ClientHeight)-1; // -1..+1

 eye.x:= x;
 eye.y:= y;
 eye.z:=-1;

 mouse.x:=x;
 mouse.y:=y;
 mouse.z:=1;

 glGetFloatv(GL_MODELVIEW_MATRIX,modelf);
 glGetFloatv(GL_PROJECTION_MATRIX,projectf);
 InvertMatrix(MulMatrix(modelf,projectf),unproject);

 eye  :=ApplyMatrix(unproject,eye  );
 mouse:=ApplyMatrix(unproject,mouse);

 nearest:=-1;
 ndist:=1000;

 for i:=0 to 601 do begin
  a:=Faces[3*i  ];
  b:=Faces[3*i+1];
  c:=Faces[3*i+2];
  move(Vertices[3*a],v1,sizeof(v1));
  move(Vertices[3*b],v2,sizeof(v2));
  move(Vertices[3*c],v3,sizeof(v3));
  dist:=Intersection(eye,mouse,v1,v2,v3);
  if (dist>=0)and(dist<=ndist) then begin
   nearest:=i;
   ndist:=dist;
  end;
 end;

 if nearest<0 then exit;
 glDisable(GL_DEPTH_TEST);
 glColor3f(1,0,0);
 glBegin(GL_TRIANGLES);
  a:=Faces[3*nearest];
  b:=Faces[3*nearest+1];
  c:=Faces[3*nearest+2];
  glArrayElement(a);
  glArrayElement(b);
  glArrayElement(c);
 glEnd;
 glEnable(GL_DEPTH_TEST);
end;

procedure square(x,y,z:single);
const
 k=0.1;
begin
 glVertex3f(x-k,y-k,z);
 glVertex3f(x+k,y-k,z);
 glVertex3f(x+k,y+k,z);
 glVertex3f(x-k,y+k,z);
end;

procedure TForm1.SetupTiger;
var
 i:integer;
 a,b,c:integer;
 x1,y1,z1:single;
 x2,y2,z2:single;
 x3,y3,z3:single;
 nx,ny,nz:single;
 vl:single;
begin
 texture:=LoadBitmap('tiger.bmp');
 for i:=0 to 601 do begin
  a:=Tiger.Faces[3*i  ];
  b:=Tiger.Faces[3*i+1];
  c:=Tiger.Faces[3*i+2];

  x1:=Tiger.Vertices[3*b  ];
  y1:=Tiger.Vertices[3*b+1];
  z1:=Tiger.Vertices[3*b+2];

  x2:=Tiger.Vertices[3*c  ];
  y2:=Tiger.Vertices[3*c+1];
  z2:=Tiger.Vertices[3*c+2];

  x3:=Tiger.Vertices[3*a  ];
  y3:=Tiger.Vertices[3*a+1];
  z3:=Tiger.Vertices[3*a+2];

  x1:=x1-x3;
  y1:=y1-y3;
  z1:=z1-z3;

  x2:=x2-x3;
  y2:=y2-y3;
  z2:=z2-z3;

  nx:=y1*z2-y2*z1;
  ny:=z1*x2-z2*x1;
  nz:=x1*y2-x2*y1;
  vl:=sqrt(nx*nx+ny*ny+nz*nz);
  if vl<>0 then begin
   vl:=1/vl;
   nx:=nx*vl;
   ny:=ny*vl;
   nz:=nz*vl;
  end;

  normals[i].x:=nx;
  normals[i].y:=ny;
  normals[i].z:=nz;
 end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 caption:=IntToStr(FPS)+' FPS'; FPS:=0;
end;

procedure TForm1.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
begin
 Invalidate;
end;

procedure TForm1.FormCreate(Sender: TObject);
 var
  pfd:TPIXELFORMATDESCRIPTOR;
  pixelformat:integer;
 begin
 // Windows DC
  fDC:=GetDC(Handle);
 // set pixel format
  FillChar(pfd,SizeOf(pfd),0);
  pfd.nSize       := sizeof(pfd);
  pfd.nVersion    := 1;
  pfd.dwFlags     := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
  pfd.iLayerType  := PFD_MAIN_PLANE;
  pfd.iPixelType  := PFD_TYPE_RGBA;
  pfd.cColorBits  := 24;
  pfd.iLayerType  :=PFD_MAIN_PLANE;
  pixelformat:=ChoosePixelFormat(fDC, @pfd);
  if PixelFormat=0 then RaiseLastOSError;
  if not SetPixelFormat(fDC, pixelformat, @pfd) then RaiseLastOSError;
 // create OpenGL Context
  fGL:=wglCreateContext(fDC);
 // select it
  wglMakeCurrent(fDC,fGL);
 // init the first screen
  glClear(GL_COLOR_BUFFER_BIT);
 // setup the clear color
  glClearColor(0,0,0,0);
 // setup the clear depth
  glClearDepth(1);
 // enable/disable capabilities
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_DEPTH_TEST);
 // define Depth function
  glDepthFunc(GL_LESS);
 // and shade model
  glShadeModel(GL_SMOOTH);

  SetupTiger;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
// some exit conditions
 if (fGL=0)or(ClientHeight=0) then exit;
// setup viewport
 glViewport(0, 0, ClientWidth, ClientHeight);
// default projection mode
 glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(45,ClientWidth/ClientHeight,1,1000);
 glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 if fGL<>0 then begin
  glDeleteTextures(1,texture);
  wglDeleteContext(fGL);
  ReleaseDC(Handle,fDC);
 end;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
 i:integer;
begin
 if fGL=0 then exit;

 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glLoadIdentity;

 inc(fps);
 glTranslatef(0,0,-4);
 glRotatef(rx,1,0,0);
 glRotatef(GetTickCount/50,0,1,0);
 glTranslatef(tx,ty,0);

// glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 glVertexPointer(3,GL_FLOAT,0,@Tiger.Vertices);
 glTexCoordPointer(2,GL_FLOAT,0,@Tiger.Mapping);
 glEnableClientState(GL_VERTEX_ARRAY);
 glEnableClientState(GL_TEXTURE_COORD_ARRAY);

 glColor3f(1,1,1);
 glBegin(GL_TRIANGLES);
  for i:=0 to 601 do begin
   glArrayElement(Tiger.Faces[3*i  ]);
   glArrayElement(Tiger.Faces[3*i+1]);
   glArrayElement(Tiger.Faces[3*i+2]);
  end;
 glEnd;

 Selection;

 glDisableClientState(GL_VERTEX_ARRAY);
 glDisableClientState(GL_TEXTURE_COORD_ARRAY);

 SwapBuffers(fDC);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mm:=ord(button)+1;
 mx:=x;
 my:=y;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mm:=0;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 case mm of
  1:rx:=rx+(mx-x);
  2:ty:=ty+(my-y)/100;
 end;
 mx:=x;
 my:=y;
end;

procedure TForm1.wmEraseBkGnd(var msg:TMessage);
 begin
  msg.result:=1;
 end;

end.
